Logo Questions Linux Laravel Mysql Ubuntu Git Menu
 

Commit in git only if tests pass

I've recently started using git, and also begun unit testing (using Python's unittest module). I'd like to run my tests each time I commit, and only commit if they pass.

I'm guessing I need to use pre-commit in /hooks, and I've managed to make it run the tests, but I can't seem to find a way to stop the commit if they tests fail. I'm running the tests with make test, which in turn is running python3.1 foo.py --test. It seems like I don't get a different exit condition whether the tests pass or fail, but I may be looking in the wrong place.

Edit: Is this something uncommon that I want to do here? I would have thought it was a common requirement...

Edit2: Just in case people can't be bothered to read the comments, the problem was that unittest.TextTestRunner doesn't exit with non-zero status, whether the test suite is successful or not. To catch it, I did:

result = runner.run(allTests) if not result.wasSuccessful():     sys.exit(1) 
like image 929
Skilldrick Avatar asked Jan 18 '10 15:01

Skilldrick


People also ask

How do I commit without verify?

Quick tip if you want to skip the pre-commit validations and quickly want to get a commit out there. To get your commit through without running that pre-commit hook, use the --no-verify option. Voila, without pre-commit hooks running!


1 Answers

I would check to make sure that each step of the way, your script returns a non-zero exit code on failure. Check to see if your python3.1 foo.py --test returns a non-zero exit code if a test fails. Check to make sure your make test command returns a non-zero exit code. And finally, check that your pre-commit hook itself returns a non-zero exit code on failure.

You can check for a non-zero exit code by adding || echo $? to the end of a command; that will print out the exit code if the command failed.

The following example works for me (I'm redirecting stderr to /dev/null to avoid including too much extraneous output here):

$ python3.1 test.py 2>/dev/null || echo $? 1 $ make test 2>/dev/null || echo $? python3.1 test.py 2 $ .git/hooks/pre-commit 2>/dev/null || echo $? python3.1 test.py 1 

test.py:

import unittest  class TestFailure(unittest.TestCase):     def testFail(self):         assert(False)  if __name__ == '__main__':     unittest.main() 

Makefile:

test:     python3.1 test.py 

.git/hooks/pre-commit:

#!/bin/sh make test || exit 1 

Note the || exit 1. This isn't necessary if make test is the last command in the hook, as the exit status of the last command will be the exit status of the script. But if you have later checks in your pre-commit hook, then you need to make sure you exit with an error; otherwise, a successful command at the end of the hook will cause your script to exit with a status of 0.

like image 186
Brian Campbell Avatar answered Oct 05 '22 22:10

Brian Campbell